## Examples

This directory contains examples for various Configurate usage patterns. These examples may be referenced in the documentation. For any documentation references, please remember to link to a specific tag.

All code within this subproject is *non-API*. The contents may change at any time and exist for reference purposes *only*.

For those looking to provide examples, the following standards apply to code in this module:

- Examples must be self-contained: While it may make sense for some data structures to be shared, there should be no helper methods used between classes.
- Examples should be heavily commented: Whether it's to point out an interesting feature of the library, or to explain the choices made, examples are made to be read by people new to the library. Even if something is in the Javadocs, if it's key to understanding the library it should be stated.
- The wiki should be coordinated with the examples: The wiki is one of the first places people are directed when looking to work with Configurate. Make sure to update it when changes are made.
